﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


using System.Collections.Generic;

using System.Windows.Controls;
using System.Windows.Media;
using System.Windows;

using System.Globalization; // CultureInfo
using System.Collections;  // ArrayList
using System.Windows.Input; // Cursor

using System.IO;
using System.Windows.Threading;

namespace PythonIDE.ColorText {
    class MyColorTextBox2 : Canvas {

        static String fontname = "Consolas";

        enum ColorTyp {
            html,
            text,
            space,
            specialchars,
            comments
        }

        class ColorString {
            public StringBuilder sb = new StringBuilder();
            public ColorTyp colortyp = ColorTyp.text;
        }
        class StringList {
            public int anzTabs = 0;
            public List<ColorString> colorstrings = new List<ColorString>();
        }
        class LineAbschnitt2 {
            public bool isFertig = false;
            public bool setComment = false;
            public ColorString colorstring = null;
            public String line = "";

            public LineAbschnitt2(String line) {
                this.line = line;
            }
            public LineAbschnitt2(ColorString colorstring) {
                this.colorstring = colorstring;
            }
        }

        // py
        private String[] highlightItems = new String[] {
            "def",
            "__init__",
            "self",
            "tkinter",
            "Frame",
            "bottom",
            "top",
            "class",
            "do",
            "double",
            "print",
            "else",
            "if",
            "float",
            "for",
            "config",
            "range",
            "input",
            "if",
            "new",
            "None",
            "both",
            "ttk",
            "import",
            "from",
            "while",
            "column",
            "row",
            "heading",
            "anchor",
            "width",
            "in",
            "int",
            "bin",
            "minwidth",
            "stretch",
            "text",
            "open",
            "values",
            "os",
            "padx",
            "pady",
            "expand",
            "return",
            "strlen",
            "True",
            "False",
            "finally",
            "exception",
            "pack",
            "Scrollbar",
            "fill",
            "side",
            "command",
            "quit",
            "right",
            "left",
            "tree",
            "xview",
            "yview",
            "insert",
            "title",
            "geometry",
            "MyApp",
            "mainloop",
            "messagebox",
            "showinfo",
            "try"
        };


        SolidColorBrush penLinenumber = new SolidColorBrush(Colors.Black);

        Brush backgroundColor = new SolidColorBrush(Color.FromRgb(250, 250, 250));

        Brush brushHTML = new SolidColorBrush(Colors.Blue);
        Brush brushNormalText = new SolidColorBrush(Colors.Black);
        Brush brushSpecialChars = new SolidColorBrush(Colors.Red);
        Brush brushComment = new SolidColorBrush(Colors.LightYellow);
        Brush brushLightBlue = new SolidColorBrush(Colors.LightBlue);

        Brush brushRed = new SolidColorBrush(Colors.Red);

        private MyTextBox mytextbox = null;
        private String editText = null;
        private string[] lines = null;

        private List<StringList> gesamtliste = new List<StringList>();

        double spacesize = 0;
        double leftMargin = 0;
        double rowHeight = 0;

        //public int width = 200;
        //public int height = 200;
        private int fontsize = 14;

        private int actualRow = 1;
        private int numberOfRows = 10;

        private IColorText parentColorText = null;

        private double tabsize = 2;

        private DispatcherTimer dispatcherTimer = new DispatcherTimer();

        private Typeface typefaceLineNumber = new Typeface(new FontFamily(fontname), FontStyles.Normal, FontWeights.Normal, FontStretches.Normal);

        private Typeface typefaceNormal = new Typeface(new FontFamily(fontname), FontStyles.Normal, FontWeights.Normal, FontStretches.Normal);
        private Typeface typefaceBold = new Typeface(new FontFamily(fontname), FontStyles.Normal, FontWeights.DemiBold, FontStretches.Normal);


        public MyColorTextBox2(IColorText parentColorText, MyTextBox mytextbox) {
            this.parentColorText = parentColorText;

            try {
                colorChanged();
                this.mytextbox = mytextbox;
                this.editText = mytextbox.Text.Replace(Konst.C_TAB, " ");


                splitText();

                //this.PreviewKeyDown += MyColorTextBox2_PreviewKeyDown;
                //this.KeyDown += MyColorTextBox2_KeyDown;
                this.MouseLeftButtonDown += MyTextBoxMouseLeftButtonDown;


                double w = ActualWidth;
                double h = ActualHeight;

                // setFontsize(14);

                leftMargin = 47;
                rowHeight = 15.86;
                spacesize = 8.4; ;
                numberOfRows = (int)(Height / rowHeight);

                dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
                dispatcherTimer.Interval = TimeSpan.FromMilliseconds(500);
                dispatcherTimer.Start();
            }
            catch (Exception e) {
                Basis.ErrorMsg("Exception im Konstruktor\r\n" + e.ToString(), "Fehler");
            }
        }

        private void dispatcherTimer_Tick(object sender, EventArgs e) {
            dispatcherTimer.Stop();
            CommandManager.InvalidateRequerySuggested();
            int size = Basis.ReadRegInt(SingVar.C_REG_ADR, "fontcolorsize");
            if (size == 0) {
                size = 14;
            }
            setFontsize(size);
        }

        public void setFontsize(int size) {
            try {
                fontsize = size;
                FormattedText formattedText = new FormattedText("00000",
                              CultureInfo.GetCultureInfo("DE-de"),
                              FlowDirection.LeftToRight,
                              typefaceLineNumber,
                               fontsize, new SolidColorBrush(Colors.Black)); // text.brushText));                   
                leftMargin = formattedText.Width + 5;
                rowHeight = formattedText.Height;

                formattedText = new FormattedText("m",
                                          CultureInfo.GetCultureInfo("DE-de"),
                                          FlowDirection.LeftToRight,
                                          new Typeface(fontname),
                                           fontsize, new SolidColorBrush(Colors.Black)); // text.brushText));         
                spacesize = formattedText.Width;
                numberOfRows = (int)(ActualHeight / rowHeight);
            }
            catch (Exception e) {
                Basis.ErrorMsg("Exception im setFontsize\r\n" + e.ToString(), "Fehler");
            }
        }

        private ColorTyp checkColorTyp(char ch) {
            try {
                int code = ch;
                if ((code >= 65 && code <= 90) || (code >= 97 && code <= 122) || (code >= 48 && code <= 57) ||
                    (code == 220) || (code == 196) || (code == 214) || (code == 252) || (code == 228) || (code == 246) || (code == 223)) {
                    return ColorTyp.text;
                }
                else if (code == 32) {
                    return ColorTyp.space;
                }

                else if ((code >= 33 && code <= 47) || (code >= 58 && code <= 64) || (code >= 91 && code <= 96) || (code >= 123 && code <= 126))
                    return ColorTyp.specialchars;
                else {
                    Basis.Message("Fehlerhafte Abfrage in checkColorTyp: char: " + ch, "Info");
                    return ColorTyp.text;
                }
            }
            catch (Exception e) {
                Basis.ErrorMsg("Exception im checkColorTyp\r\n" + e.ToString(), "Fehler");
                return ColorTyp.text;
            }
        }

        private ColorTyp checkColorTypScript(char ch) {
            try {
                int code = ch;
                if ((code >= 65 && code <= 90) || (code >= 97 && code <= 122) || (code >= 48 && code <= 57) || (code == 95) ||
                    (code == 220) || (code == 196) || (code == 214) || (code == 252) || (code == 228) || (code == 246) || (code == 223)) {
                    return ColorTyp.text;
                }
                else if (code == 32) {
                    return ColorTyp.space;
                }
                else {
                    return ColorTyp.specialchars;
                }
            }
            catch (Exception e) {
                Basis.ErrorMsg("Exception im checkColorTypScript\r\n" + e.ToString(), "Fehler");
                return ColorTyp.text;
            }
        }
        public void setModell(MyTextBox mytextbox) {
            this.mytextbox = mytextbox;
            this.editText = mytextbox.Text.Replace(Konst.C_TAB, " ");
            string[] splitStrings = { "\r\n" };
            lines = editText.Split(splitStrings, StringSplitOptions.None);
            actualRow = 1;
            splitText();
            InvalidateVisual();
        }

        public void setTabsize(double tabsize) {
            this.tabsize = tabsize;
            InvalidateVisual();
        }



        private void splitText() {
            try {
                gesamtliste.Clear();
                // private List<StringList> liste = new List<StringList>();
                string[] splitStrings = { "\r\n" };
                lines = editText.Split(splitStrings, StringSplitOptions.None);

                


                bool scriptBlock = true;
                bool scriptComment2 = false;
                StringList stringListLine = null;  // 1x pro Zeile
                ColorString colorstring = null;  // mehrfach pro Zeile
                                                 // <?xml version="1.0" encoding="UTF-8" ?>


                foreach (String line2 in lines) {
                    String line3 = line2.TrimStart();
                    stringListLine = new StringList();
                    if (line2.StartsWith("      "))
                        stringListLine.anzTabs = 6;
                    else if (line2.StartsWith("     "))
                        stringListLine.anzTabs = 5;
                    else if (line2.StartsWith("    "))
                        stringListLine.anzTabs = 4;
                    else if (line2.StartsWith("   "))
                        stringListLine.anzTabs = 3;
                    else if (line2.StartsWith("  "))
                        stringListLine.anzTabs = 2;
                    else if (line2.StartsWith(" "))
                        stringListLine.anzTabs = 1;

                    gesamtliste.Add(stringListLine);
                    colorstring = null;  // noch nichts passiert in der aktuellen Zeile
                    int posi = 0;
                    ColorString colorstringCommentSlashSlash = null;
                    ColorString colorstringCommentBlock = null;  // 

                    if (scriptBlock) {  // checkColorTypScript
                        List<LineAbschnitt2> lineAbschnittListe = new List<LineAbschnitt2>();

                        lineAbschnittListe.Add(new LineAbschnitt2(line3));
                        while (lineAbschnittListe.Count > 0) {
                            LineAbschnitt2 abschnitt = lineAbschnittListe[0];
                            lineAbschnittListe.RemoveAt(0);
                            if (abschnitt.isFertig) {
                                stringListLine.colorstrings.Add(abschnitt.colorstring);
                                if (abschnitt.setComment) {
                                    //    $w=12;  /*    
                                    scriptComment2 = true;
                                    colorstringCommentBlock = abschnitt.colorstring;  // 1. Teil  /*    ....
                                }
                                continue;
                            }


                            String lineLoop = abschnitt.line;

                            if (scriptComment2) {
                                // suche */
                                posi = lineLoop.IndexOf("*/");
                                if (posi >= 0) {
                                    // ende des Kommentars?         */  $w=12;   /*    ddddd  */
                                    scriptComment2 = false;
                                    // ende Kommentar-Block in die Zeilenabschnittsliste
                                    String linex = lineLoop.Substring(0, posi + 2);  // 2=*/
                                    ColorString colorstring22 = new ColorString();
                                    colorstring22.colortyp = ColorTyp.comments;
                                    colorstring22.sb.Append(linex);
                                    stringListLine.colorstrings.Add(colorstring22);
                                    // den Rest in die While-Liste
                                    linex = lineLoop.Substring(posi + 2);
                                    if (linex.Trim().Length > 0) {
                                        LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                        lineAbschnittListe.Insert(0, abschnitt3);
                                    }
                                    continue;
                                }
                                else {
                                    // komplette Zeile als Kommentar!
                                    if (colorstringCommentBlock == null) {
                                        colorstringCommentBlock = new ColorString();
                                        colorstringCommentBlock.colortyp = ColorTyp.comments;
                                        stringListLine.colorstrings.Add(colorstringCommentBlock);
                                    }
                                    colorstringCommentBlock.sb.Append(lineLoop);
                                    continue;
                                }
                            }
                            else {
                                // if  (!scriptComment2) {
                                posi = lineLoop.IndexOf("//");            //  suche   //  und /*
                                int posi2a = lineLoop.IndexOf("/*");
                                if (posi >= 0 && posi2a >= 0) {
                                    if (posi > posi2a) {
                                        posi = -1;
                                    }
                                    else {
                                        posi2a = -1;
                                    }
                                }

                                if (posi >= 0) {
                                    String str_comment = lineLoop.Substring(posi);
                                    lineLoop = lineLoop.Substring(0, posi);
                                    colorstringCommentSlashSlash = new ColorString();
                                    // teste, welche Gruppe
                                    colorstringCommentSlashSlash.colortyp = ColorTyp.comments;
                                    colorstringCommentSlashSlash.sb.Append(str_comment);
                                }

                                // kein scriptComment2
                                posi = lineLoop.IndexOf("/*");
                                if (posi >= 0) {
                                    // Check, in aktuelle Zeile zu Ende?                              
                                    int posi2 = lineLoop.IndexOf("*/");
                                    if (posi2 >= 0) {
                                        if (posi2 > posi) {
                                            //  a) /*     */      b) int a=1  /*    */    c)  /*  */  a=1     d) a=1; /*   */  b=1;
                                            // umgekehrte Reihenfolge

                                            // text nach den Klammern
                                            String linex = lineLoop.Substring(posi2 + 2);
                                            if (linex.Trim().Length > 0) {
                                                LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                                lineAbschnittListe.Insert(0, abschnitt3);
                                            }

                                            // der Klammerbereich
                                            linex = lineLoop.Substring(posi, posi2 - posi + 2);
                                            ColorString colorStringkl = new ColorString();
                                            colorStringkl.colortyp = ColorTyp.comments;
                                            colorStringkl.sb.Append(linex);
                                            LineAbschnitt2 abschnitt5 = new LineAbschnitt2(colorStringkl);
                                            abschnitt5.isFertig = true;
                                            abschnitt5.setComment = false;
                                            lineAbschnittListe.Insert(0, abschnitt5);

                                            // vor dem Klammerbereich
                                            if (posi > 0) {
                                                linex = lineLoop.Substring(0, posi);
                                                if (linex.Length > 0) {
                                                    LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                                    lineAbschnittListe.Insert(0, abschnitt3);
                                                }
                                            }
                                            continue;
                                        }
                                        else {
                                            // Fall: max zwei Abschnitte!   int a=1;  /*       int a=1; in die Liste am Anfang
                                            // Klammerbereich, aktivieren des SetComments
                                            String linex = lineLoop.Substring(posi);
                                            ColorString colorStringkl = new ColorString();
                                            colorStringkl.colortyp = ColorTyp.comments;
                                            colorStringkl.sb.Append(linex);
                                            LineAbschnitt2 abschnitt5 = new LineAbschnitt2(colorStringkl);
                                            abschnitt5.isFertig = true;
                                            abschnitt5.setComment = true;
                                            lineAbschnittListe.Insert(0, abschnitt5);

                                            linex = lineLoop.Substring(0, posi - 1);
                                            if (linex.Length > 0) {
                                                LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                                lineAbschnittListe.Insert(0, abschnitt3);
                                            }
                                            continue;
                                        }
                                    }
                                    else {
                                        //  /*  fängt an

                                        // Fall: zwei Abschnitte!   int a=1;  /*     int a=1; in die Liste am Anfang
                                        String linex = lineLoop.Substring(posi);
                                        ColorString colorStringkl = new ColorString();
                                        colorStringkl.colortyp = ColorTyp.comments;
                                        colorStringkl.sb.Append(linex);
                                        LineAbschnitt2 abschnitt5 = new LineAbschnitt2(colorStringkl);
                                        abschnitt5.isFertig = true;
                                        abschnitt5.setComment = true;  // !!!!
                                        lineAbschnittListe.Insert(0, abschnitt5);

                                        if (posi > 0) {
                                            linex = lineLoop.Substring(0, posi - 1);
                                            if (linex.Length > 0) {
                                                LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                                lineAbschnittListe.Insert(0, abschnitt3);
                                            }
                                        }
                                        continue;  // 
                                    }
                                }
                            }

                            foreach (char ch in lineLoop) {
                                if (colorstring == null) {
                                    colorstring = new ColorString();
                                    stringListLine.colorstrings.Add(colorstring);
                                    // teste, welche Gruppe
                                    colorstring.colortyp = checkColorTypScript(ch);
                                    colorstring.sb.Append(ch);
                                }
                                else {
                                    ColorTyp colortyp = checkColorTypScript(ch);
                                    // test, ob die Gruppe identisch ist
                                    if (colorstring.colortyp == colortyp) {
                                        colorstring.sb.Append(ch);
                                    }
                                    else {
                                        colorstring = new ColorString();
                                        stringListLine.colorstrings.Add(colorstring);
                                        // neue Gruppe
                                        colorstring.colortyp = colortyp;
                                        colorstring.sb.Append(ch);
                                    }
                                }

                            }  // foreach (char ch in line) {
                               // nun loop über alle AbschnittsTexte und check mit den Items der highlight-Liste
                        }  // while lineAbschnittListe.Count>0
                        if (colorstringCommentSlashSlash != null) {
                            stringListLine.colorstrings.Add(colorstringCommentSlashSlash);
                        }
                        foreach (ColorString colorstring2 in stringListLine.colorstrings) {
                            if (colorstring2.colortyp != ColorTyp.comments) {
                                foreach (String items in highlightItems) {
                                    if (colorstring2.sb.ToString().Equals(items)) {
                                        colorstring2.colortyp = ColorTyp.html;
                                        break;
                                    }
                                }
                            }
                        }
                        int jjj = 33;
                        // 
                    }
                    else {
                        foreach (char ch in line3) {
                            if (colorstring == null) {
                                colorstring = new ColorString();
                                stringListLine.colorstrings.Add(colorstring);
                                // teste, welche Gruppe
                                colorstring.colortyp = checkColorTyp(ch);
                                colorstring.sb.Append(ch);
                            }
                            else {
                                ColorTyp colortyp = checkColorTyp(ch);
                                // test, ob die Gruppe identisch ist
                                if (colorstring.colortyp == colortyp) {
                                    colorstring.sb.Append(ch);
                                }
                                else {
                                    colorstring = new ColorString();
                                    stringListLine.colorstrings.Add(colorstring);
                                    // neue Gruppe
                                    colorstring.colortyp = colortyp;
                                    colorstring.sb.Append(ch);
                                }
                            }

                        }  // foreach (char ch in line) {
                    }
                    // <script type="text/javascript">  <?php  <%     </script   ?>  %>
                }  // foreach (String line in lines) {
            }
            catch (Exception e) {
                Basis.ErrorMsg("Exception im splitText\r\n" + e.ToString(), "Fehler");
            }
        }

        public void colorChanged() {
            backgroundColor = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.FontcolordialogBackgroundRed, (byte)SingVar.FontcolordialogBackgroundGreen, (byte)SingVar.FontcolordialogBackgroundBlue));
            penLinenumber = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.LineNumberColordialogForegroundRed, (byte)SingVar.LineNumberColordialogForegroundGreen, (byte)SingVar.LineNumberColordialogForegroundBlue));
            brushHTML = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.HtmlColordialogForegroundRed, (byte)SingVar.HtmlColordialogForegroundGreen, (byte)SingVar.HtmlColordialogForegroundBlue));
            brushNormalText = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.NormalTextColordialogForegroundRed, (byte)SingVar.NormalTextColordialogForegroundGreen, (byte)SingVar.NormalTextColordialogForegroundBlue));
            brushSpecialChars = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.SpecialCharactersColordialogForegroundRed, (byte)SingVar.SpecialCharactersColordialogForegroundGreen, (byte)SingVar.SpecialCharactersColordialogForegroundBlue));
            brushComment = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.CommentColordialogForegroundRed, (byte)SingVar.CommentColordialogForegroundGreen, (byte)SingVar.CommentColordialogForegroundBlue));
            this.Background = backgroundColor;

        }



        public void MyColorTextBox2_KeyDown(Object sender, KeyEventArgs e) {
            numberOfRows = (int)Math.Truncate(ActualHeight / rowHeight);
            if (Keyboard.IsKeyDown(Key.Down)) {
                e.Handled = true;
                actualRow++;
                InvalidateVisual();
            }
            if (Keyboard.IsKeyDown(Key.Up)) {
                e.Handled = true;
                if (actualRow > 1) {
                    actualRow--;
                    InvalidateVisual();
                }

            }
            if (Keyboard.IsKeyDown(Key.PageDown)) {
                e.Handled = true;
                if (actualRow + numberOfRows + numberOfRows - 1 <= lines.Length) {
                    actualRow += numberOfRows - 1;
                }
                else {
                    actualRow = lines.Length - numberOfRows + 1;
                }
                InvalidateVisual();
            }
            if (Keyboard.IsKeyDown(Key.PageUp)) {
                e.Handled = true;
                if (actualRow > numberOfRows) {
                    actualRow -= numberOfRows - 1;
                }
                else {
                    actualRow = 1;
                }
                InvalidateVisual();
            }

            if (Keyboard.IsKeyDown(Key.Home)) {
                e.Handled = true;
                actualRow = 1;
                InvalidateVisual();
            }
            if (Keyboard.IsKeyDown(Key.End)) {
                e.Handled = true;
                actualRow = lines.Length - numberOfRows + 1;
                InvalidateVisual();
            }

        }
        void MyTextBoxMouseLeftButtonDown(object sender, MouseButtonEventArgs e) {
            base.OnMouseLeftButtonDown(e);
        }




        double breite2 = 0;
        private void UserControl_SizeChanged(Object sender, SizeChangedEventArgs e) {
            breite2 = ActualWidth;
        }

        public int setStartrow(int startrow) {
            if (startrow > 0) {
                if (startrow > lines.Length - numberOfRows + 1) {
                    actualRow = lines.Length - numberOfRows + 1;
                }
                else {
                    actualRow = startrow;
                    InvalidateVisual();
                }
            }
            return actualRow;
        }

        public void setSize(double breite, double hoehe) {
            this.breite2 = breite;
            Width = breite;
            numberOfRows = (int)(Height / rowHeight);
            //Height = hoehe;  // 
            InvalidateVisual();
        }

        public void setTypeFaces(Typeface typefaceNormal, Typeface typefaceBold) {
            this.typefaceNormal = typefaceNormal;
            this.typefaceBold = typefaceBold;
            InvalidateVisual();
        }

        protected void OnRender2(DrawingContext dc) {
            base.OnRender(dc);
            Pen pen2 = new Pen(Brushes.Black, 2);
            pen2.DashStyle = DashStyles.Dash;
            double w = ActualWidth;
            double h = ActualHeight;
            Rect rect22 = new Rect(0, 0, Width, Height);
            dc.DrawRectangle(Brushes.White, pen2, rect22);
        }

        protected override void OnRender(DrawingContext dc) {
            base.OnRender(dc);
            FormattedText formattedText;
            double y = 0;

            numberOfRows = (int)(ActualHeight / rowHeight);
            parentColorText.setNumberofRows(lines.Length, numberOfRows);

            if (actualRow < 1) {
                return;
            }

            for (int i = actualRow; i <= gesamtliste.Count; i++) {
                StringList lineListe = gesamtliste[i - 1];

                formattedText = new FormattedText(i.ToString("000"),
                          CultureInfo.GetCultureInfo("DE-de"),
                          FlowDirection.LeftToRight,
                          typefaceLineNumber,
                           fontsize, penLinenumber); // text.brushText));                   

                dc.DrawText(formattedText, new Point(5, y));



                Brush brush;

                double x = leftMargin;
                if (lineListe.anzTabs > 0) {
                    x += lineListe.anzTabs * spacesize * tabsize;
                }
                Typeface typeface = typefaceNormal;
                foreach (ColorString colorstring2 in lineListe.colorstrings) {
                    switch (colorstring2.colortyp) {
                        case ColorTyp.html:
                            brush = brushHTML;
                            typeface = typefaceBold;
                            break;
                        case ColorTyp.space:
                            brush = brushSpecialChars;
                            typeface = typefaceNormal;
                            break;
                        case ColorTyp.specialchars:
                            brush = brushSpecialChars;
                            typeface = typefaceNormal;
                            break;
                        case ColorTyp.text:
                            brush = brushNormalText;
                            typeface = typefaceNormal;
                            break;
                        case ColorTyp.comments:
                            brush = brushComment;
                            typeface = typefaceNormal;
                            break;
                        default:
                            brush = brushNormalText;
                            typeface = typefaceNormal;
                            break;
                    }

                    if (colorstring2.colortyp == ColorTyp.space) {
                        if (colorstring2.sb.ToString().Equals(" ")) {
                            if (ActualWidth - x > 0) {
                            }
                            else {
                                break;
                            }
                            x += spacesize;
                        }
                        else if (colorstring2.sb.ToString().Equals("  ")) {
                            if (ActualWidth - x > 0) {
                            }
                            else {
                                break;
                            }
                            x += spacesize + spacesize;
                        }
                        else if (colorstring2.sb.ToString().Equals("   ")) {
                            if (ActualWidth - x > 0) {
                            }
                            else {
                                break;
                            }
                            x += spacesize + spacesize + spacesize + spacesize;
                        }
                        else if (colorstring2.sb.ToString().Equals("    ")) {
                            if (ActualWidth - x > 0) {
                            }
                            else {
                                break;
                            }
                            x += spacesize + spacesize + spacesize + spacesize + spacesize;
                        }
                    }
                    else {
                        formattedText = new FormattedText(colorstring2.sb.ToString(),
                                    CultureInfo.GetCultureInfo("DE-de"),
                                    FlowDirection.LeftToRight,
                                    typeface,
                                    fontsize, brush); // text.brushText));                   
                        if (ActualWidth - x > 0) {
                            formattedText.MaxTextWidth = ActualWidth - x;
                            formattedText.MaxLineCount = 1;
                            //formattedText.MaxTextHeight
                            dc.DrawText(formattedText, new Point(x, y));
                        }
                        else {
                            break;
                        }
                        x += formattedText.Width; // + spacesize;

                    }
                }

                y += rowHeight;
                if (y >= (ActualHeight + rowHeight)) {
                    break;
                }
            }

            // MessageBox.Show("paint");
        }

    }
}
