﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;



using Microsoft.Win32;
//using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;
using System.Diagnostics;    // OpenDialog
using PythonIDE.ColorText;
using System.Windows.Threading;

// Referenz
// Assemblies Framework
// 1) Windowsformintegration

// 2) system.windows.Forms
// 3) System.Drawing

// self.editor.get('1.0', END+'-1c'))

namespace PythonIDE {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, IDeleteTabExecuted, IParentSetRowColumnModify, IParentColorText {

        private String windowname= "mainWindow";

        WShowColorText colordialog = null;

        private bool isFullscreen = false;

        public MainWindow() {
            InitializeComponent();
        }

        private String search = "";
        private Boolean ignoreCase = false;

        private int mainfontsize;
        private int editorfontsize;
        private int tabnr = 0;

        private SingVar singvar = SingVar.getInstance();


        private void Window_Loaded(object sender, RoutedEventArgs e) {
            mainfontsize = 14;
            editorfontsize = 16;

            CommandBindings.Add(new CommandBinding(MyCommands.Newfile, NewFileExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Openfile, OpenFileExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Savefile, SaveExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.SaveAll, SaveAllExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.SaveAsfile, SaveAsExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Undo, UndoExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Redo, RedoExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Copy, CopyExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Paste, PasteExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Cut, CutExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Selectall, SelectallExecuted, CheckCanExecuted));
            
            CommandBindings.Add(new CommandBinding(MyCommands.Find, FindExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.FindAgain, FindAgainExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Colormemo, ColormemoExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.ColormemoDeleteRegistry, ColormemoDeleteRegistryExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Fullscreen, FullscreenTextExecuted, CheckCanExecuted));


            CommandBindings.Add(new CommandBinding(MyCommands.Close, CloseExecuted));


            CommandBindings.Add(new CommandBinding(MyCommands.Optionen, OptionsExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.ProgInfo, ProgInfoExecuted));


            CommandBindings.Add(new CommandBinding(MyCommands.CloseRegister, CloseRegisterExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Register2Left, Register2LeftExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Register2Right, Register2RightExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Notepad, NotepadExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Editor2Notepad, Editor2NotepadExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Start, StartExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.StartDebug, StartDebugExecuted, CheckCanExecuted));
           
            loadOldFiles();

            int fs;
            fs = Basis.ReadRegInt(SingVar.C_REG_ADR, "mainfontsize");
            if (fs > 0)
                setFontsizeRegistry(fs);
            else
                setFontsizeRegistry(mainfontsize);

            fs = Basis.ReadRegInt(SingVar.C_REG_ADR, "fontsizeeditor");
            if (fs > 0)
                setEditorFontsizeRegistry(fs);
            else
                setEditorFontsizeRegistry(editorfontsize);

            DispatcherTimer dispatcherTimer = new DispatcherTimer();
            dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
            // dispatcherTimer.Interval = new TimeSpan(0, 0, 1);  // hour, min, sec, ms
            dispatcherTimer.Interval = TimeSpan.FromMilliseconds(300);
            dispatcherTimer.Start();


            Basis.setWindowPositionFromRegistry(this, SingVar.C_REG_ADR, windowname);

        } // Window_Loaded

        int timertick = 0;
        private void dispatcherTimer_Tick(object sender, EventArgs e) {
            MyTextBox edit;
            timertick++;
            int index = tabcontrol.SelectedIndex;
            if (index>=0 && index< tabcontrol.Items.Count) {
                TabItem tabpage = (TabItem) tabcontrol.Items[index];
                edit = (MyTextBox)tabpage.Content;
                edit.setLineNummer();
                //if (timertick >= 30) {
                //    edit.getModell().saveTempFile();
                //}

            }
            else {
                this.labelRow.Content = "Zl: ";
                this.labelColumn.Content = "Sp: ";
            }
            if (timertick >= 30) {
                timertick = 0;
            }
            CommandManager.InvalidateRequerySuggested();
        }

        public void setRowColumn(int row, int column) {
            this.labelRow.Content = "Zl: " + row;
            this.labelColumn.Content = "Sp: " + column;
        }

        private void loadOldFiles() {
            int n = Basis.ReadRegInt(SingVar.C_REG_ADR, "files");
            String filename;
            for (int i = 0; i < n; i++) {
                filename = Basis.ReadRegString(SingVar.C_REG_ADR, "file" + i);
                if (File.Exists(filename)) {
                    insertFile(filename);
                }
            }
            if (n>0) {
                tabcontrol.SelectedIndex = 0;
            }
        }




        public void setFocus(MyTextBox edit) {
            edit.Text ="aaaa\r\n" + edit.Text;
            edit.Focus();
        }

        private void mnDosEbene_Click(object sender, RoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                edit.saveFile();
                Process Prog = new Process();
                Prog.StartInfo.FileName = "cmd.exe";
                Prog.StartInfo.Arguments = "";
                if (edit.Filename.Equals(""))
                    Prog.StartInfo.WorkingDirectory = Environment.CurrentDirectory;
                else
                    Prog.StartInfo.WorkingDirectory = Basis.getPath(edit.Filename);
                Prog.Start();
            }
        }  // mnDosEbene_Click




        private void clearFontMenues(object sender) {
            mnFont8pg.IsChecked = false;
            mnFont10pg.IsChecked = false;
            mnFont12pg.IsChecked = false;
            mnFont14pg.IsChecked = false;
            mnFont16pg.IsChecked = false;
            mnFont18pg.IsChecked = false;
            mnFont20pg.IsChecked = false;
            mnFont24pg.IsChecked = false;
            mnFont28pg.IsChecked = false;

            mnFont30pg.IsChecked = false;
            mnFont32pg.IsChecked = false;
            mnFont34pg.IsChecked = false;
            mnFont36pg.IsChecked = false;
            mnFont38pg.IsChecked = false;
            mnFont40pg.IsChecked = false;
            mnFont42pg.IsChecked = false;
            mnFont44pg.IsChecked = false;
            mnFont46pg.IsChecked = false;
            mnFont48pg.IsChecked = false;
            mnFont50pg.IsChecked = false;
            mnFont52pg.IsChecked = false;
            mnFont54pg.IsChecked = false;
            mnFont56pg.IsChecked = false;
            mnFont58pg.IsChecked = false;
            MenuItem mnItem = (MenuItem)sender;
            mnItem.IsChecked = true;
        }

        private void clearFontEditorMenues(object sender) {
            mnFontEditor8pg.IsChecked = false;
            mnFontEditor10pg.IsChecked = false;
            mnFontEditor12pg.IsChecked = false;
            mnFontEditor14pg.IsChecked = false;
            mnFontEditor16pg.IsChecked = false;
            mnFontEditor18pg.IsChecked = false;
            mnFontEditor20pg.IsChecked = false;
            mnFontEditor24pg.IsChecked = false;
            mnFontEditor28pg.IsChecked = false;

            mnFontEditor30pg.IsChecked = false;
            mnFontEditor32pg.IsChecked = false;
            mnFontEditor34pg.IsChecked = false;
            mnFontEditor36pg.IsChecked = false;
            mnFontEditor38pg.IsChecked = false;
            mnFontEditor40pg.IsChecked = false;
            mnFontEditor42pg.IsChecked = false;
            mnFontEditor44pg.IsChecked = false;
            mnFontEditor46pg.IsChecked = false;
            mnFontEditor48pg.IsChecked = false;
            mnFontEditor50pg.IsChecked = false;
            mnFontEditor52pg.IsChecked = false;
            mnFontEditor54pg.IsChecked = false;
            mnFontEditor56pg.IsChecked = false;
            mnFontEditor58pg.IsChecked = false;
            MenuItem mnItem = (MenuItem)sender;
            mnItem.IsChecked = true;
        }

        private void setEditorFontsizeRegistry(int fs) {


            if (fs == 8) {
                mnFontEditor8pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor8pg);
                setEditorFontsize(8);
            }
            if (fs == 10) {
                mnFontEditor10pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor10pg);
                setEditorFontsize(10);
            }
            if (fs == 12) {
                mnFontEditor12pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor12pg);
                setEditorFontsize(12);
            }
            if (fs == 14) {
                mnFontEditor14pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor14pg);
                setEditorFontsize(14);
            }
            if (fs == 16) {
                mnFontEditor16pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor16pg);
                setEditorFontsize(16);
            }
            if (fs == 18) {
                mnFontEditor18pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor18pg);
                setEditorFontsize(18);
            }
            if (fs == 20) {
                mnFontEditor20pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor20pg);
                setEditorFontsize(20);
            }
            if (fs == 24) {
                mnFontEditor24pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor24pg);
                setEditorFontsize(24);
            }
            if (fs == 28) {
                mnFontEditor28pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor28pg);
                setEditorFontsize(28);
            }
            if (fs == 30) {
                mnFontEditor30pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor30pg);
                setEditorFontsize(30);
            }
            if (fs == 32) {
                mnFontEditor32pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor32pg);
                setEditorFontsize(32);
            }
            if (fs == 34) {
                mnFontEditor34pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor34pg);
                setEditorFontsize(34);
            }
            if (fs == 36) {
                mnFontEditor36pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor36pg);
                setEditorFontsize(36);
            }
            if (fs == 38) {
                mnFontEditor38pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor38pg);
                setEditorFontsize(38);
            }
            if (fs == 40) {
                mnFontEditor40pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor40pg);
                setEditorFontsize(40);
            }
            if (fs == 42) {
                mnFontEditor42pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor42pg);
                setEditorFontsize(42);
            }
            if (fs == 44) {
                mnFontEditor44pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor44pg);
                setEditorFontsize(44);
            }
            if (fs == 46) {
                mnFontEditor46pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor46pg);
                setEditorFontsize(46);
            }
            if (fs == 48) {
                mnFontEditor48pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor48pg);
                setEditorFontsize(48);
            }
            if (fs == 50) {
                mnFontEditor50pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor50pg);
                setEditorFontsize(50);
            }
            if (fs == 52) {
                mnFontEditor52pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor52pg);
                setEditorFontsize(52);
            }
            if (fs == 54) {
                mnFontEditor54pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor54pg);
                setEditorFontsize(54);
            }
            if (fs == 56) {
                mnFontEditor56pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor56pg);
                setEditorFontsize(56);
            }
            if (fs == 58) {
                mnFontEditor58pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor58pg);
                setEditorFontsize(58);
            }
        }

        private void setFontsizeRegistry(int fs) {
            if (fs == 8) {
                mnFont8pg.IsChecked = true;
                clearFontMenues(mnFont8pg);
                setFontsize(8);
            }
            if (fs == 10) {
                mnFont10pg.IsChecked = true;
                clearFontMenues(mnFont10pg);
                setFontsize(10);
            }
            if (fs == 12) {
                mnFont12pg.IsChecked = true;
                clearFontMenues(mnFont12pg);
                setFontsize(12);
            }
            if (fs == 14) {
                mnFont14pg.IsChecked = true;
                clearFontMenues(mnFont14pg);
                setFontsize(14);
            }
            if (fs == 16) {
                mnFont16pg.IsChecked = true;
                clearFontMenues(mnFont16pg);
                setFontsize(16);
            }
            if (fs == 18) {
                mnFont18pg.IsChecked = true;
                clearFontMenues(mnFont18pg);
                setFontsize(18);
            }
            if (fs == 20) {
                mnFont20pg.IsChecked = true;
                clearFontMenues(mnFont20pg);
                setFontsize(20);
            }
            if (fs == 24) {
                mnFont24pg.IsChecked = true;
                clearFontMenues(mnFont24pg);
                setFontsize(24);
            }
            if (fs == 28) {
                mnFont28pg.IsChecked = true;
                clearFontMenues(mnFont28pg);
                setFontsize(28);
            }
            if (fs == 30) {
                mnFont30pg.IsChecked = true;
                clearFontMenues(mnFont30pg);
                setFontsize(30);
            }
            if (fs == 32) {
                mnFont32pg.IsChecked = true;
                clearFontMenues(mnFont32pg);
                setFontsize(32);
            }
            if (fs == 34) {
                mnFont34pg.IsChecked = true;
                clearFontMenues(mnFont34pg);
                setFontsize(34);
            }
            if (fs == 36) {
                mnFont36pg.IsChecked = true;
                clearFontMenues(mnFont36pg);
                setFontsize(36);
            }
            if (fs == 38) {
                mnFont38pg.IsChecked = true;
                clearFontMenues(mnFont38pg);
                setFontsize(38);
            }
            if (fs == 40) {
                mnFont40pg.IsChecked = true;
                clearFontMenues(mnFont40pg);
                setFontsize(40);
            }
            if (fs == 42) {
                mnFont42pg.IsChecked = true;
                clearFontMenues(mnFont42pg);
                setFontsize(42);
            }
            if (fs == 44) {
                mnFont44pg.IsChecked = true;
                clearFontMenues(mnFont44pg);
                setFontsize(44);
            }
            if (fs == 46) {
                mnFont46pg.IsChecked = true;
                clearFontMenues(mnFont46pg);
                setFontsize(46);
            }
            if (fs == 48) {
                mnFont48pg.IsChecked = true;
                clearFontMenues(mnFont48pg);
                setFontsize(48);
            }
            if (fs == 50) {
                mnFont50pg.IsChecked = true;
                clearFontMenues(mnFont50pg);
                setFontsize(50);
            }
            if (fs == 52) {
                mnFont52pg.IsChecked = true;
                clearFontMenues(mnFont42pg);
                setFontsize(52);
            }
            if (fs == 54) {
                mnFont54pg.IsChecked = true;
                clearFontMenues(mnFont44pg);
                setFontsize(54);
            }
            if (fs == 56) {
                mnFont56pg.IsChecked = true;
                clearFontMenues(mnFont46pg);
                setFontsize(56);
            }
            if (fs == 58) {
                mnFont58pg.IsChecked = true;
                clearFontMenues(mnFont48pg);
                setFontsize(58);
            }
        }


        private void setEditorFontsize(int size) {
            this.editorfontsize = size;
            Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsizeeditor", size);
            MyTextBox edit;
            foreach (MyTabItem tabpage in tabcontrol.Items) {
                edit = (MyTextBox)tabpage.Content;
                edit.setFontsize(size);
                tabpage.setFontsize(editorfontsize);
            }
        }
        private void setFontsize(int size) {
            this.mainfontsize = size;
            Basis.WriteRegInt(SingVar.C_REG_ADR, "mainfontsize", size);
            bnStart.FontSize = size;
            bnStartWithDos.FontSize = size;
            mainMenu.FontSize = size;
        }

        private void mnFont_Click(object sender, RoutedEventArgs e) {
            System.Windows.Controls.MenuItem mn = (MenuItem)sender;
            clearFontMenues(sender);
            setFontsize(Convert.ToInt32(mn.Tag));
        }
        private void mnFontEditor_Click(object sender, RoutedEventArgs e) {
            System.Windows.Controls.MenuItem mn = (MenuItem)sender;
            clearFontEditorMenues(sender);
            setEditorFontsize(Convert.ToInt32(mn.Tag));

        }
        //private void mnFont_Click(object sender, RoutedEventArgs e) {
        //    System.Windows.Controls.MenuItem mn = (System.Windows.Controls.MenuItem)sender;
        //    clearFontMenues(sender);
        //    setFontsize(Convert.ToInt32(mn.Tag));
        //}

        private void CheckCanExecuted(object sender, CanExecuteRoutedEventArgs e) {
            e.CanExecute = tabcontrol.Items.Count > 0;
        }
        private bool isLoadedinTabControl(string sFilename) {
            MyTextBox edit;
            foreach (TabItem tabpage in tabcontrol.Items) {
                edit = (MyTextBox)tabpage.Content;
                if (edit.Filename.Equals(sFilename, StringComparison.CurrentCultureIgnoreCase)) {
                    return true;
                }
            }
            return false;
        }

        public void insertFile(String filename) {
            int index = -1;
            if (Keyboard.Modifiers.HasFlag(ModifierKeys.Shift)) {
                tabcontrol.Items.Clear();
            }

            if (!isLoadedinTabControl(filename)) {
                insertFile2TabControl(filename);
                index = tabcontrol.Items.Count;
            }

            if (index > -1) tabcontrol.SelectedIndex = index - 1;

        }

        public void insertFile2TabControl(String filename) {
            MyTabItem tabPage1 = new MyTabItem(this, ++tabnr);
            tabPage1.Title = Basis.getFilename(filename);
            tabPage1.ToolTip = filename;
            tabPage1.setFontsize(mainfontsize);
            tabPage1.FontSize = mainfontsize;

            MyTextBox edit = new MyTextBox(this, this, tabPage1, filename, 1);
            tabPage1.Content = edit;
            tabcontrol.Items.Add(tabPage1);

            
            edit.setFontsize(this.editorfontsize);
            edit.loadFile();
            edit.Modified = false;

            tabPage1.FontSize = mainfontsize;
            tabPage1.Focus();
        }

        private void NotepadExecuted(object sender, ExecutedRoutedEventArgs e) {
            Process Prog = new Process();
            Prog.StartInfo.FileName = "Notepad.exe";
            Prog.StartInfo.Arguments = "";
            Prog.Start();
        }

        private void Editor2NotepadExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                edit.saveFile();
                Process Prog = new Process();
                Prog.StartInfo.FileName = "Notepad.exe";
                Prog.StartInfo.Arguments = edit.Filename;
                Prog.Start();
            }

        }

        private void StartExecuted(object sender, ExecutedRoutedEventArgs e) {
            mnStartPythonScript(false);
        }
        private void StartDebugExecuted(object sender, ExecutedRoutedEventArgs e) {
            mnStartPythonScript(true);
        }

        private void mnStartPythonScript(bool withCMD) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                if (edit.Filename.Length > 0)
                    edit.saveFile();
                else
                    SaveAsExecuted(null, null);
                if (edit.Filename.Length > 0) {
                    startPython(edit.Filename, withCMD);
                }
            }
        }

        internal void startPython(String filename, bool withCMD) {
            Process Prog = new Process();
            if (withCMD) {
                Prog.StartInfo.FileName = "cmd.exe";
                Prog.StartInfo.Arguments = "/k " + filename;
            }
            else {
                Prog.StartInfo.FileName = filename;
                Prog.StartInfo.Arguments = "";
            }
            Prog.StartInfo.WorkingDirectory = Basis.getPath(filename);
            Prog.Start();
        }


        private void CloseRegisterExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit;
            int index = tabcontrol.SelectedIndex;
            if (index >= 0) {
                TabItem tabpage = (TabItem)tabcontrol.Items[index];
                edit = (MyTextBox)tabpage.Content;
                if (edit.Modified) {
                    MessageBoxResult res = Basis.readYesNoCancel("Save the changes?", "Close the programm");
                    switch (res) {
                        case MessageBoxResult.Yes: edit.saveFile();
                            break;
                        case MessageBoxResult.No:
                            break;
                        case MessageBoxResult.Cancel: return;
                    }
                }
                tabcontrol.Items.RemoveAt(index);
            }

        } // closeRegister

        private void Register2LeftExecuted(object sender, ExecutedRoutedEventArgs e) {
            int index = tabcontrol.SelectedIndex;
            if (index > 0) {
                TabItem tabpage = (TabItem)tabcontrol.Items[index];
                tabcontrol.Items.RemoveAt(index);
                tabcontrol.Items.Insert(index - 1, tabpage);
                tabcontrol.SelectedIndex = index - 1;
                tabpage = (TabItem)tabcontrol.Items[index - 1];
                ((MyTextBox)tabpage.Content).Focus();
            }
        }

        private void Register2RightExecuted(object sender, ExecutedRoutedEventArgs e) {
            int index = tabcontrol.SelectedIndex;
            if (index < (tabcontrol.Items.Count - 1)) {
                TabItem tabpage = (TabItem)tabcontrol.Items[index];
                tabcontrol.Items.RemoveAt(index);
                tabcontrol.Items.Insert(index + 1, tabpage);
                tabcontrol.SelectedIndex = index + 1;
                tabpage = (TabItem)tabcontrol.Items[index+1];
                ((MyTextBox)tabpage.Content).Focus();
            }
        }


        private void NewFileExecuted(object sender, ExecutedRoutedEventArgs e) {
           insertFile("");
        }  // mnNew_Click



        private void OpenFileExecuted(object sender, ExecutedRoutedEventArgs e) {
            Microsoft.Win32.OpenFileDialog openFileDialog1 = new Microsoft.Win32.OpenFileDialog();
            openFileDialog1.Filter = "Python-Files (*.py)|*.py|" +
            "All files (*.*)|*.*";

            openFileDialog1.FilterIndex = 1;// zählt von 1 !
            openFileDialog1.DefaultExt = ".py";
            openFileDialog1.InitialDirectory = singvar.PythonPath;
            openFileDialog1.Multiselect = true;
            openFileDialog1.RestoreDirectory = true;
            openFileDialog1.Title = "Open file(s)";

            if (openFileDialog1.ShowDialog() == true) {
                if (Keyboard.Modifiers.HasFlag(ModifierKeys.Shift)) {
                    tabcontrol.Items.Clear();
                }

                foreach (String sFilename in openFileDialog1.FileNames) {
                    insertFile(sFilename);
                    singvar.LastPath = Basis.getPath(sFilename);                    
                }
            }
        }

        private void SaveAllExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit;
            foreach (TabItem tabpage in tabcontrol.Items) {
                edit = (MyTextBox)tabpage.Content;
                edit.saveFile();
            }
        }

        private void SaveExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {                
                if (edit.Filename.Length>0)
                    edit.saveFile();
                else
                    SaveAsExecuted(sender, e);
            }
        }


        private void SaveAsExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            Microsoft.Win32.SaveFileDialog saveFileDialog1 = new Microsoft.Win32.SaveFileDialog();
            saveFileDialog1.Title = "Save as";
            saveFileDialog1.Filter = "Python files (*.py)|*.py|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".py";
            saveFileDialog1.InitialDirectory = singvar.PythonPath;
            if (edit != null && edit.Filename.Length > 0) {
                saveFileDialog1.FileName = edit.Filename;

            }
            saveFileDialog1.RestoreDirectory = true;
            if (saveFileDialog1.ShowDialog() == true) {
                if (edit != null) {
                    String filename = edit.Filename.ToLower();
                    edit.Filename = saveFileDialog1.FileName.ToString();
                    edit.saveFile();
                }
            }
        }  // mnSaveAs_Click


        private MyTextBox getActiveEditor() {
            MyTextBox edit;
            if (tabcontrol.Items.Count>0 && tabcontrol.SelectedIndex>=0) {
                TabItem tabPage1 = (TabItem)tabcontrol.Items[tabcontrol.SelectedIndex];
                edit = (MyTextBox)tabPage1.Content;
                return edit;
            }
            else {
                return null;
            }
        }





        private void UndoExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) edit.Undo();
        }
        private void RedoExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            //if (edit != null) edit.Re
        }

        private void CopyExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) edit.Copy();
        }

        private void PasteExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) edit.Paste();
        }
        private void CutExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) edit.Cut();
        }

        private void SelectallExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                edit.SelectAll();
            }
        }


        // suche nun das Register
        public void DeleteTabExecuted(int nr) {
            if (tabcontrol.Items.Count > 0) {
                MyTabItem tabpage;
                for (int i = 0; i < tabcontrol.Items.Count; i++) {
                    tabpage = (MyTabItem)tabcontrol.Items[i];
                    if (tabpage.Nr == nr) {
                        MyTextBox edit = (MyTextBox)tabpage.Content;
                        if (edit.Modified) {
                            MessageBoxResult ret = Basis.readYesNoCancel(
                                "Save the changes?\r\n" + edit.Filename, "Close the register");
                            if (ret == MessageBoxResult.Cancel) return;
                            if (ret == MessageBoxResult.OK) {
                                if (edit.Filename != null)
                                    edit.saveFile();
                                else
                                    SaveAsExecuted(null, null);
                            }
                            tabcontrol.Items.RemoveAt(i);
                        }
                        else {
                            tabcontrol.Items.RemoveAt(i);
                        }
                    } // if
                } // for
            }// if
        }

        private void FindExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {

                WFind dialog = new WFind(this);
                dialog.ShowDialog();
                if (dialog.Result) {
                    search = dialog.SearchString;
                    ignoreCase = dialog.IgnoreCase;
                    edit.Search = search;
                    edit.searchText(search, ignoreCase);
                }
            }
        }

        private void FindAgainExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                edit.searchAgain();
            }
        }

        public void deleteColorDialog() {
            colordialog = null;
        }


        private void ColormemoExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                if (colordialog == null) {
                    colordialog = new WShowColorText(this, edit);
                    colordialog.Show();
                    //Thread.Sleep(500);
                    //colordialog.setEdit(edit);
                }
                else {
                    colordialog.setEdit(edit);
                }
            }
        }


        private void ColormemoDeleteRegistryExecuted(object sender, ExecutedRoutedEventArgs e) {
            String title = "WShowColorText";
            Basis.WriteRegInt(SingVar.C_REG_ADR, title + "_Top1", 10);
            Basis.WriteRegInt(SingVar.C_REG_ADR, title + "_Left1", 10);
            Basis.WriteRegInt(SingVar.C_REG_ADR, title + "_Width1", 300);
            Basis.WriteRegInt(SingVar.C_REG_ADR, title + "_Height1", 200);
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Escape) && isFullscreen) {
                FullscreenTextExecuted(sender, null);
            }
        }
        private void FullscreenTextExecuted(object sender, ExecutedRoutedEventArgs e) {
            if (isFullscreen) {
                mainMenu.Visibility = Visibility.Visible;
                toolBarTray1.Visibility = Visibility.Visible;
                isFullscreen = false;
                foreach (TabItem tabpage in tabcontrol.Items) {
                    MyTextBox edit = (MyTextBox)tabpage.Content;
                    edit.setMainMenu(Visibility.Visible);
                }
            }
            else {
                mainMenu.Visibility = Visibility.Collapsed;
                toolBarTray1.Visibility = Visibility.Collapsed;

                foreach (TabItem tabpage in tabcontrol.Items) {
                    MyTextBox edit = (MyTextBox)tabpage.Content;
                    edit.setMainMenu(Visibility.Collapsed);
                }
                isFullscreen = true;
            }

        }

        public void editorIsModfied() {
            if (SingVar.ColorEditorAktualiserung) {
                MyTextBox edit = getActiveEditor();
                if (edit != null && colordialog != null) {
                    colordialog.setEdit(edit);
                }
            }
        }


        private void CloseExecuted(object sender, ExecutedRoutedEventArgs e) {
            Close();
        }




        private void OptionsExecuted(object sender, ExecutedRoutedEventArgs e) {
            WOptions dialog = new WOptions(this);
            dialog.ShowDialog();
            if (dialog.retcode) {
                MyTextBox edit;
                foreach (TabItem tabpage in tabcontrol.Items) {
                    edit = (MyTextBox)tabpage.Content;
                    edit.setColors();
                }
            }            
        }

        private void ProgInfoExecuted(object sender, ExecutedRoutedEventArgs e) {
            WProgInfo dialog = new WProgInfo(this);
            dialog.ShowDialog();
        }




        private void insertText(String text) {
            System.Windows.Clipboard.SetDataObject(text.Replace("\t", Konst.C_TAB));
            MyTextBox edit = getActiveEditor();
            if (edit != null) edit.Paste();
        }

        private void mnLanguage_if_Click(object sender, RoutedEventArgs e) {
            insertText("\tif a == 0:\r\n\t\t");
        }

        private void mnLanguage_ifelse_Click(object sender, RoutedEventArgs e) {
            insertText("\tif a == 0:\r\n\t\tpass\r\n\telse:\r\n\t\tpass");
        }

        private void mnIfElifElse_Click(object sender, RoutedEventArgs e) {
            insertText("\tif a == 0:\r\n\t\tpass\r\n\telif b == 0:\r\n\t\tpass\r\n\telse:\r\n\t\tpass");
        }

        private void mnWhile_Click(object sender, RoutedEventArgs e) {
            insertText("\twhile True:\r\n\t\tpass");
        }

        private void mnForeach_Cick(object sender, RoutedEventArgs e) {
            insertText("\tfor i in [1,2,3]:\r\n\t\tprint(i)");
        }

        private void mnForeachRange_Cick(object sender, RoutedEventArgs e) {
            insertText("\tfor i in range(1,10,2):\r\n\t\tprint(i)");
        }

        private void mnInt2String_Click(object sender, RoutedEventArgs e) {
            insertText("\tiValue=str(123)");
        }

        private void mnDouble2String_Click(object sender, RoutedEventArgs e) {
            insertText("\tdValue=str(123.4)");
        }

        private void mnString2Int_Click(object sender, RoutedEventArgs e) {
            insertText("\tiValue=int('123')");
        }

        private void mnString2Float_Click(object sender, RoutedEventArgs e) {
            insertText("\tfValue=float('123.4')");
        }

        private void mnShowType_Click(object sender, RoutedEventArgs e) {
            insertText("\tprint('type(var1): ', type(var1))");
        }

        private void mnPythonFunction_Abs_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tvar1 = abs(-12)\r\n"
            );
        }

        private void mnPythonFunction_Fabs_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tvar1 = math.fabs(-12.5)\r\n"
            );
        }

        private void mnPythonFunction_Min_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tvar1 = min([1,2,3])\r\n"
            );
        }

        private void mnPythonFunction_Max_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tvar1 = max([1,2,3])\r\n"
            );
        }

        private void mnPythonFunction_Exp_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tvar1 = math.exp(1)\r\n"
            );
        }

        private void mnPythonFunction_Log10_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tvar1 = math.log10(11)\r\n"
            );
        }

        private void mnPythonFunction_LogxBase_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tvar1 = math.log(100,10)\t ==> 2\r\n"
            );
        }

        private void mnPythonFunction_Ln_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tvar1 = math.log(11)\t  ln(11) ==> 2.3978952727983707\r\n"
            );
        }

        private void mnPythonFunction_Sqrt_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tvar1 = math.sqrt(2)\r\n"
            );
        }

        private void mnPythonFunction_Floor_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tvar1 = math.floor(-12.2)\t  => -13\r\n" +
                "\t\tvar1 = math.floor(12.2)\t  => 12\r\n"
            );
        }

        private void mnPythonFunction_Trunc_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tvar1 = math.floor(-12.2)\t  => -12\r\n" +
                "\t\tvar1 = math.floor(12.2)\t  => 12\r\n"
            );
        }

        private void mnPythonFunction_Round_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tvar1 = round(12.2)\t  => 12\r\n" +
                "\t\tvar1 = round(12.5)\t  => 12\r\n" +
                "\t\tvar1 = round(12.6)\t  => 13\r\n" +
                "\t\tvar1 = round(12.66,1)\t  => 12.7\r\n"
            );
        }


        private void mnPython_Function_Click(object sender, RoutedEventArgs e) {
            insertText("\tdef fktname(param1):\r\n\t\tprint(param1)");
        }

        private void mnPython_IntFunction_Click(object sender, RoutedEventArgs e) {
            insertText("\tdef fktname(value):\r\n\t\tprint(value)\r\n\treturn value+1");
        }

        private void mnPython_TupleFunction_Click(object sender, RoutedEventArgs e) {
            insertText("def fktname(value):\r\n\t\tprint(param)\r\n\t# Abfrage: t[0], t[1]\r\n\treturn (value+1, value+2)");
        }

        private void mnPython_list_Click(object sender, RoutedEventArgs e) {
            insertText(
                "# einfache Liste\r\n" +
                "liste = [1,2,13,13,35,6,7,8,9]\r\n" +
                "print(\"Ausgabe mit foreach:\")\r\n" +
                "for item in liste:\r\n" +
                "\tprint(item)\r\n" +
                "print()\r\n" +
                "print(\"Ausgabe mit for range:\")\r\n" +
                "for i in range(0,len(liste),1):\r\n" +
                "\tprint( liste[i] )\r\n" +
                "Methoden\r\n" +
                "# Anzahl der Elemente in der Liste: len(liste) \r\n" +
                "# Min-Element: min(liste) \r\n" +
                "# Max-Element: max(liste) \r\n" +
                "# Suche 6: liste.count(6) \r\n" +
                "# Position von 13: liste.index(13) \r\n" +
                "# insert: liste.insert(42,1)\r\n" +
                "# liste.reverse()\r\n"
                );
        }

        private void mnPython_Dict_Click(object sender, RoutedEventArgs e) {
            insertText(
                "noten = {27456:1.3 , 27457:3.3 , 27459:2.7 , \"Brücke\":\"Extrakäse\" } \r\n" +
                "for key in noten: \r\n" +
                "\tprint(key) \r\n" +
                "print(\"Ausgabe mit einem Key:\") \r\n" +
                "print( noten[27456] ) \r\n" +
                "for key in noten.keys(): \r\n" +
                "\tprint(key, \"  \",noten[key]) \r\n" +
                "print(\"Anzahl der Elemente in der Dictionary\", len(noten) ) \r\n"
            );
        }

        private void mnPython_Set_Click(object sender, RoutedEventArgs e) {
            insertText(
                "s = set( (2,3,5,7) ) \r\n" +
                "for item in s: \r\n" +
                "\tprint(item) \r\n\r\n" +
                "print() \r\n" +
                "s.add(\"Pizza\") \r\n" +
                "s.add(\"Pizza\") \r\n\r\n" +
                "for item in s: \r\n" +
                "\tprint(item) \r\n\r\n" +
                "print() \r\n" +
                "print(len(s)) \r\n"
            );
        }

        private void mnPython_Exception_Click(object sender, RoutedEventArgs e) {
            insertText(
                "try:\r\n" +
                "\ta = int('abc')\r\n" +
                "except ValueError as e:\r\n" +
                "\tprint(\"fehlerhafte Zahl\")\r\n\r\n" +
                "\t# IndexError\r\n" +
                "\t# ArithmeticError\r\n" +
                "\t# EOFError\r\n" +
                "\t# IOError\r\n" +
                "\t# AttributeError  hat kein Instanz hat kein Attribut\r\n" +
                "\t# MemoryError\r\n" +
                "\t# OverflowError\r\n" +
                "\t# ZeroDivisionError\r\n\r\n" +
                "# raise ValueError('represents a hidden bug, do not catch this')"
            );
        }

        private void mnPython_ExceptionCompleteSyntax_Click(object sender, RoutedEventArgs e) {
            insertText(
                "try:\r\n" +
                "\ta = int('abc')\r\n" +
                "except ValueError as e1:\r\n" +
                "\tprint(\"fehlerhafte Zahl\")\r\n\r\n" +
                "except OverflowError as e2:\r\n" +
                "\tprint(\"overflowError\")\r\n\r\n" +
                "else:\r\n" +
                "\t#ausgefuehrt, wenn keine Exception erzeugt wurde\r\n" +
                "\tpass\r\n" +
                "finally:\r\n" +
                "\t#immer ausgefuehrt\r\n" +
                "\tpass\r\n\r\n" +
                "# raise ValueError('represents a hidden bug, do not catch this')"

            );
        }

        private void mnPython_SimpleClass_Click(object sender, RoutedEventArgs e) {
            insertText("class Punkt:\r\n" +
                           "\tdef __init__(self, x, y):\r\n" +
                           "\t\tself.x=x\r\n" +
                           "\t\tself.y=y\r\n\r\n" +
                           "\tdef __str__(self):\t# toString\r\n" +
                           "\t\treturn str(self.x)+\", \"+str(self.y)" + "\r\n" +
                           "# main\r\n" +
                           "p1 = Punkt(12,3)\r\n" +
                           "p1.x=42\r\n" +
                           "print(p1.x,p1.y)\r\n");
        }

        private void mnPython_ClassGetterSetter_Click(object sender, RoutedEventArgs e) {
            insertText("class Punkt:\r\n" +
                           "\tdef __init__(self, x):\r\n" +
                           "\t\tself._X=x\r\n\r\n" +
                           "\tdef getX(self):\r\n" +
                           "\t\treturn self._X\r\n\r\n" +
                           "\tdef setX(self,x):\r\n" +
                           "\t\tself._X=x\r\n\r\n" +
                           "# main\r\n" +
                           "p1 = Punkt(12)\r\n" +
                           "p1.setX(42)\r\n" +
                           "print(p1.getX())\r\n");
        }

        private void mnPython_2Class_Click(object sender, RoutedEventArgs e) {
            insertText("class Schiff:\r\n" +
                        "\tdef __init__(self, name):\r\n\r\n" +
                        "\t\tself._name=name\r\n" +
                        "\tdef getName(self):\r\n" +
                        "\t\treturn self._name\r\n\r\n" +
                        "\tdef setName(self,name):\r\n" +
                        "\t\tself._name=name\r\n\r\n" +

                        "class Frachter(Schiff):\r\n\r\n" +
                        "\tdef __init__(self, name, frachtvolumen):\r\n" +
                        "\t\tSchiff.__init__(self, name)\r\n" +
                        "\t\tself._frachtvolumen=frachtvolumen\r\n\r\n" +
                        "\tdef getFrachtvolumen(self):\r\n" +
                        "\t\treturn self._frachtvolumen\r\n\r\n" +
                        "\tdef setFrachtvolumen(self,frachtvolumen):\r\n" +
                        "\t\tself._frachtvolumen=frachtvolumen\r\n\r\n" +
                        "\tdef __str__(self):\r\n" +
                        "\t\treturn Schiff.getName(self)+\"  \"+str(self.getFrachtvolumen())\r\n\r\n" +
                        "# main\r\n" +
                        "s1 = Schiff(\"Titanic\")\r\n" +
                        "s1.setName(\"Queen Mary\")\r\n" +
                        "print(s1.getName())\r\n" +
                        "f1 = Frachter(\"KaesePizza\", 12000)\r\n" +
                        "f1.setFrachtvolumen(14000)\r\n" +
                        "print(f1)\r\n");
        }

        private void mnPython_InputString_Click(object sender, RoutedEventArgs e) {
            insertText("inp = input(\"Please input a text\")\r\nprint(inp)");
        }

        private void mnPython_InputInt_Click(object sender, RoutedEventArgs e) {
            insertText("zahl = int(input(\"Please input a int number\"))\r\nprint(zahl)");
        }

        private void mnPython_InputFloat_Click(object sender, RoutedEventArgs e) {
            insertText("zahl = float(input(\"Please input a float number\"))\r\nprint(zahl)");
        }

        private void mnPython_ImportOS_Click(object sender, RoutedEventArgs e) {
            insertText("import os\r\n");
        }

        private void mnPython_ImportOSPath_Click(object sender, RoutedEventArgs e) {
            insertText("import os.path\r\n");
        }

        private void mnPython_Params_Click(object sender, RoutedEventArgs e) {
            insertText("import sys\r\n\r\n" +
                        "print(len(sys.argv))\r\n\r\n" +
                        "if len(sys.argv)>0:\r\n" +
                        "\t# kompletter Name des Skriptes\r\n" +
                        "\tprint(sys.argv[0])\r\n\r\n"
            );
        }

        private void mnPython_GetWorkingDir_Click(object sender, RoutedEventArgs e) {
            insertText("\t\tpath = getcwd()\r\n");
        }

        private void mnPython_Listdir_Click(object sender, RoutedEventArgs e) {
            insertText("\t\titems = os.listdir(path)\r\n");
        }

        private void mnPython_Isdir_Click(object sender, RoutedEventArgs e) {
            insertText("\t\tvalue = os.path.isdir(item)\r\n");
        }

        private void mnPython_Isfile_Click(object sender, RoutedEventArgs e) {
            insertText("\t\tvalue = os.path.isfile(item)\r\n");
        }

        private void mnPython_TKinterFramePack_Click(object sender, RoutedEventArgs e) {
            insertText(
                "import tkinter\r\n\r\n" +
                "class MyApp(tkinter.Frame):\r\n\r\n" +
                "\tdef __init__(self, master=None):\r\n" +
                "\t\ttkinter.Frame.__init__(self, master)\r\n" +
                "\t\tself.pack(expand=True, fill=\"both\") \r\n" +
                "\t\tself.setGUI()\r\n\r\n" +
                "\tdef setGUI(self):\r\n" +
                "\t\tself.inputui = tkinter.Entry(self)\r\n" +
                "\t\tself.inputui.pack()\r\n" +
                "\t\tself.bnEsc = tkinter.Button(self)\r\n" +
                "\t\tself.bnEsc[\"text\"] = \"Ende\"\r\n" +
                "\t\tself.bnEsc[\"command\"] = self.quit\r\n" +
                "\t\tself.bnEsc.pack(side=\"right\")\r\n\r\n" +

                "root = tkinter.Tk()\r\n" +
                "root.title(\"Mein Fenster\")\r\n" +
                "root.geometry(\"350x200\")\r\n" +
                "app = MyApp(root)\r\n" +
                "app.mainloop()\r\n"
            );
        }

        private void mnPython_TKinterFrameGrid_Click(Object sender, RoutedEventArgs e) {
            insertText(
                "import tkinter\r\n" +
                "from tkinter import messagebox\r\n\r\n" +

                "class MyApp():\r\n\r\n" +
                "\tdef __init__(self, root):\r\n" +
                "\t\troot.config(bg=\"yellow\")\r\n" +
                "\t\tself.setGUI()\r\n\r\n" +

                "\tdef setGUI(self):\r\n" +
                "\t\tself.label1 = tkinter.Label(root)\r\n" +
                "\t\tself.label1[\"text\"]=\"Eingabe\"\r\n" +
                "\t\tself.label1.config(foreground=\"blue\")\r\n\r\n" +

                "\t\tself.label1.config(background=\"red\")\r\n" +
                "\t\tself.label1.grid(row=0, column=0, padx=\"10\", pady=\"10\")\r\n" +
                "\t\tself.inputui = tkinter.Entry(root, background=\"blue\", foreground=\"yellow\", relief=tkinter.SUNKEN)\r\n" +
                "\t\tself.inputui.grid(row=0, column=1, sticky=\"ew\", padx=\"10\", pady=\"10\")\r\n\r\n" +

                "\t\tself.var_name = tkinter.StringVar()\r\n" +
                "\t\tself.var_name.set(\"Ihr Name...\")\r\n" +
                "\t\tself.inputui[\"textvariable\"] = self.var_name\r\n\r\n" +


                "\t\tself.bnAction = tkinter.Button(root)\r\n" +
                "\t\tself.bnAction[\"text\"] = \"Action\"\r\n" +
                "\t\tself.bnAction[\"command\"] = self.onAction\r\n" +
                "\t\tself.bnAction.grid(row=1, column=0, padx=\"10\", pady=\"10\")\r\n\r\n" +

                "\t\tself.bnQuit = tkinter.Button(root)\r\n" +
                "\t\tself.bnQuit[\"text\"] = \"Ende\"\r\n" +
                "\t\tself.bnQuit[\"command\"] = root.quit\r\n" +
                "\t\tself.bnQuit.grid(row=1, column=1, padx=\"10\", pady=\"10\")\r\n\r\n" +


                "\tdef onAction(self):\r\n" +
                "\t\tself.var_name.set(self.var_name.get()[::- 1])\r\n" +
                "\t\tmessagebox.showinfo(\"Hello Python\", \"Hello World\")\r\n\r\n" +


                "root = tkinter.Tk()\r\n" +
                "root.title(\"Mein Fenster\")\r\n" +
                "root.geometry(\"350x200\")\r\n" +
                "app = MyApp(root)\r\n" +
                "root.mainloop()\r\n"
            );
        }

        private bool ispack() {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                if (edit.Text.IndexOf("master=None") >= 0 || edit.Text.IndexOf(".pack") >= 0)
                        return true;
                else if (edit.Text.IndexOf("init__(self, root)") >= 0 || edit.Text.IndexOf(".grid") >= 0)
                        return false;
                else
                    return true;
            }
            else {
                return true;
            }
        }

        private void mnPython_TKinterFrameJPanel_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {
                insertText(
                    "\t\tframe1 = tkinter.Frame(self)\r\n" +
                    "\t\tframe1.pack(fill=\"x\", side=\"top\" ) \t # fill=x,y,both\r\n"
                );
            }
            else {
                insertText(
                    "\t\tframe1 = tkinter.Frame(root)\r\n" +
                    "\t\tframe1.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n"
                );
            }
        }

        private void mnPython_TKinterLabelFrame_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {
                insertText(
                    "\t\tlabelframe = tkinter.LabelFrame(self, text=\"Caption\")\r\n" +
                    "\t\tlabelframe.pack(fill=\"both\", expand=\"yes\")\r\n"
                );
            }
            else {
                insertText(
                    "\t\tlabelframe = tkinter.LabelFrame(root, text=\"Caption\")\r\n" +
                    "\t\tlabelframe.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n"
                );
            }

        }

        private void mnPython_TKinterLabel_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {
                insertText(
                    "\t\tself.label1 = tkinter.Label(self)\r\n" +
                    "\t\tself.label1[\"text\"] = \"Eingabe\"\r\n" +
                    "\t\tself.label1.pack()\r\n"
                );
            }
            else {
                insertText(
                    "\t\tself.label1 = tkinter.Label(root)\r\n" +
                    "\t\tself.label1[\"text\"] = \"Eingabe\"\r\n" +
                    "\t\tself.label1.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n"
                );
            }
        }

        private void mnPython_TKinterTextboxEntry_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {
                insertText(
                    "\t\tself.inputui = tkinter.Entry(self)\r\n" +
                    "\t\tself.inputui.pack(fill=\"x\",padx=\"5\",pady=\"5\")\r\n"
                );
            }
            else {
                insertText(
                    "\t\tself.inputui = tkinter.Entry(root)\r\n" +
                    "\t\tself.inputui.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n"
                );
            }
        }

        private void mnPython_TKinterSpinbox_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {
                insertText(
                    "\t\tself.spinbox = tkinter.Spinbox(inputframe, from_=0, to=10)\r\n" +
                    "\t\t# self.spinbox = tkinter.Spinbox(inputframe,values = (\"AI\",\"VW\",\"W\"))\r\n" +
                    "\t\tself.spinbox.pack(fill=\"x\",padx=\"5\",pady=\"5\")\r\n"
                );
            }
            else {
                insertText(
                    "\t\tself.spinbox = tkinter.Spinbox(inputframe, from_=0, to=10)\r\n" +
                    "\t\t# self.spinbox = tkinter.Spinbox(inputframe,values = (\"AI\",\"VW\",\"W\"))\r\n" +
                    "\t\tself.spinbox.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n"
                );
            }
        }

        private void mnPython_TKinterButton_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {
                insertText(
                    "\t\tself.bnOk = tkinter.Button(self)\r\n" +
                    "\t\tself.bnOk[\"text\"] = \"Ok\"\r\n" +
                    "\t\tself.bnOk[\"command\"] = self.quit\r\n" +
                    "\t\tself.bnOk.pack(side=\"right\")\r\n"

                );
            }
            else {
                insertText(
                    "\t\tself.bnOk = tkinter.Button(root)\r\n" +
                    "\t\tself.bnOk[\"text\"] = \"Ok\"\r\n" +
                    "\t\tself.bnOk[\"command\"] = root.quit\r\n" +
                    "\t\tself.bnOk..grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n"

                );
            }
        }

        private void mnPython_TKinterRadioButton_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {
                insertText(
                    "\t\tself.group = tkinter.LabelFrame(self, text=\"Noten\")\r\n" +
                    "\t\tself.group.pack(fill=\"both\", expand=\"yes\")\r\n" +
                    "\t\tself.rb1= tkinter.Radiobutton(self.group, text=\"Eins\", value=\"Eins\")\r\n" +
                    "\t\tself.rb1.pack()\r\n" +
                    "\t\tself.rb2= tkinter.Radiobutton(self.group, text=\"Zwei\", value=\"Zwei\")\r\n" +
                    "\t\tself.rb2.pack()\r\n" +
                    "\t\tself.rbProperty = tkinter.StringVar()\r\n" +
                    "\t\tself.rbProperty.set(\"Zwei\")\r\n" +
                    "\t\tself.rb1[\"variable\"] = self.rbProperty\r\n" +
                    "\t\tself.rb2[\"variable\"] = self.rbProperty\r\n"
                );
            }
            else {
                insertText(
                    "\t\tself.group = tkinter.LabelFrame(root, text=\"Noten\")\r\n" +
                    "\t\tself.group.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n" +
                    "\t\tself.rb1= tkinter.Radiobutton(self.group, text=\"Eins\", value=\"Eins\")\r\n" +
                    "\t\tself.rb1.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n" +
                    "\t\tself.rb2= tkinter.Radiobutton(self.group, text=\"Zwei\", value=\"Zwei\")\r\n" +
                    "\t\tself.rb2.grid(row=1, column=0, padx=\"10\",pady=\"10\")\r\n" +
                    "\t\tself.rbProperty = tkinter.StringVar()\r\n" +
                    "\t\tself.rbProperty.set(\"Zwei\")\r\n" +
                    "\t\tself.rb1[\"variable\"] = self.rbProperty\r\n" +
                    "\t\tself.rb2[\"variable\"] = self.rbProperty\r\n"
                );
            }
        }

        private void mnPython_TKinterCheckbox_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {
                insertText(
                    "\t\tself.group = tkinter.LabelFrame(self, text=\"Noten\")\r\n" +
                    "\t\tself.group.pack(fill=\"both\", expand=\"yes\")\r\n" +
                    "\t\tself.chk1= tkinter.Checkbutton(self)\r\n" +
                    "\t\tself.chk1[\"text\"] = \"Eins\"\r\n" +
                    "\t\tself.chk1.pack()\r\n" +
                    "\t\tself.chk2= tkinter.Checkbutton(self)\r\n" +
                    "\t\tself.chk2[\"text\"] = \"Zwei\"\r\n" +
                    "\t\tself.chk2.pack()\r\n" +
                    "\t\tself.chkProperty1 = tkinter.BooleanVar()\r\n" +
                    "\t\tself.chkProperty1.set(True)\r\n" +
                    "\t\tself.chk1[\"variable\"] = self.chkProperty1\r\n" +
                    "\t\tself.chkProperty2 = tkinter.BooleanVar()\r\n" +
                    "\t\tself.chkProperty2.set(False)\r\n" +
                    "\t\tself.chk2[\"variable\"] = self.chkProperty2\r\n"
                );
            }
            else {
                insertText(
                    "\t\tself.group = tkinter.LabelFrame(root, text=\"Noten\")\r\n" +
                    "\t\tself.group.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n" +
                    "\t\tself.chk1= tkinter.Checkbutton(root)\r\n" +
                    "\t\tself.chk1[\"text\"] = \"Eins\"\r\n" +
                    "\t\tself.chk1.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n" +
                    "\t\tself.chk2= tkinter.Checkbutton(root)\r\n" +
                    "\t\tself.chk2[\"text\"] = \"Zwei\"\r\n" +
                    "\t\tself.chk2.grid(row=1, column=0, padx=\"10\",pady=\"10\")\r\n" +
                    "\t\tself.chkProperty1 = tkinter.BooleanVar()\r\n" +
                    "\t\tself.chkProperty1.set(True)\r\n" +
                    "\t\tself.chk1[\"variable\"] = self.chkProperty1\r\n" +
                    "\t\tself.chkProperty2 = tkinter.BooleanVar()\r\n" +
                    "\t\tself.chkProperty2.set(False)\r\n" +
                    "\t\tself.chk2[\"variable\"] = self.chkProperty2\r\n"
                );
            }
        }

        private void mnPython_TKinterListBox_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {
                insertText(
                    "\t\tsb = tkinter.Scrollbar(self)\r\n" +
                    "\t\tsb.pack(fill=\"y\", side=\"right\")\r\n" +
                    "\t\tself.listbox = tkinter.Listbox(self)\t # selectmode=\"single, extended orient=\"horizontal\"   \"\r\n" +
                    "\t\tself.listbox.pack(expand=True, fill=\"both\")\r\n" +
                    "\t\tself.listbox[\"yscrollcommand\"] = sb.set\r\n" +
                    "\t\tsb[\"command\"] = self.listbox.yview\r\n" +
                    "\t\tself.listbox.insert(\"end\", \"abc\")\r\n"
                );
            }
            else {
                insertText(
                    "\t\tsb = tkinter.Scrollbar(root)\r\n" +
                    "\t\tsb.pack(fill=\"y\", side=\"right\")\r\n" +
                    "\t\tself.listbox = tkinter.Listbox(root)\t # selectmode=\"single, extended orient=\"horizontal\"   \"\r\n" +
                    "\t\tself.listbox.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n" +
                    "\t\tself.listbox[\"yscrollcommand\"] = sb.set\r\n" +
                    "\t\tsb[\"command\"] = self.listbox.yview\r\n" +
                    "\t\tself.listbox.insert(\"end\", \"abc\")\r\n"
                );
            }
        }

        private void mnPython_TKinterEditor_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {
                insertText(
                "\t\tsbx = tkinter.Scrollbar(self, orient=\"horizontal\")\r\n" +
                "\t\tsbx.pack(fill=\"x\", side=\"bottom\")\r\n\r\n" +

                "\t\tsby = tkinter.Scrollbar(self)\r\n" +
                "\t\tsby.pack(fill=\"y\", side=\"right\")\r\n\r\n" +

                "\t\tself.editor = tkinter.Text(self)\r\n" +
                "\t\tself.editor.config(wrap=\"none\")  # wrap=\"word\"  word char \r\n" +
                "\t\tself.editor.pack(expand=True, fill=\"both\", padx=\"5\",pady=\"5\")\r\n\r\n" +

                "\t\tself.editor[\"xscrollcommand\"] = sbx.set\r\n" +
                "\t\tsbx[\"command\"] = self.editor.xview\r\n" +
                "\t\tself.editor[\"yscrollcommand\"] = sby.set\r\n" +
                "\t\tsby[\"command\"] = self.editor.yview\r\n"
                );
            }
            else {
                insertText(
                "\t\tsbx = tkinter.Scrollbar(root, orient=\"horizontal\")\r\n" +
                "\t\tsbx.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n\r\n" +

                "\t\tsby = tkinter.Scrollbar(root)\r\n" +
                "\t\tsby-grid(row=0, column=1, padx=\"10\",pady=\"10\")\r\n\r\n" +

                "\t\tself.editor = tkinter.Text(root)\r\n" +
                "\t\tself.editor.config(wrap=\"none\")  # wrap=\"word\"  word char \r\n" +
                "\t\tself.editor.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n" +

                "\t\tself.editor[\"xscrollcommand\"] = sbx.set\r\n" +
                "\t\tsbx[\"command\"] = self.editor.xview\r\n" +
                "\t\tself.editor[\"yscrollcommand\"] = sby.set\r\n" +
                "\t\tsby[\"command\"] = self.editor.yview\r\n"
                );
            }
        }

        private void mnPython_Tkinter_ScrollbarVertical_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {
                insertText(
                    "\t\tsby = tkinter.Scrollbar(self)\r\n" +
                    "\t\tsby.pack(fill=\"y\", side=\"right\")\r\n\r\n" +
                    "\t\t# UI-Element\r\n" +
                    "\t\t# self.element[\"yscrollcommand\"] = sbx.set\r\n" +
                    "\t\t#sby[\"command\"] = self.element.yview\r\n"
                );
            }
            else {
                insertText(
                    "\t\tsby = tkinter.Scrollbar(root)\r\n" +
                    "\t\tsby.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n\r\n" +
                    "\t\t# UI-Element\r\n" +
                    "\t\t# self.element[\"yscrollcommand\"] = sbx.set\r\n" +
                    "\t\t#sby[\"command\"] = self.element.yview\r\n"
                );
            }
        }

        private void mnPython_Tkinter_ScrollbarHorizontal_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {
                insertText(
                    "\t\tsbx = tkinter.Scrollbar(self, orient=\"horizontal\")\r\n" +
                    "\t\tsbx.pack(fill=\"x\", side=\"bottom\")\r\n\r\n" +

                    "\t\t# UI-Element\r\n" +

                    "\t\t# self.element[\"xscrollcommand\"] = sbx.set\r\n" +
                    "\t\tsbx[\"command\"] = self.element.xview\r\n"
                );
            }
            else {
                insertText(
                    "\t\tsbx = tkinter.Scrollbar(root, orient=\"horizontal\")\r\n" +
                    "\t\tsbx.grid(row=0, column=0, padx=\"10\",pady=\"10\")\r\n" +

                    "\t\t# UI-Element\r\n" +

                    "\t\t# self.element[\"xscrollcommand\"] = sbx.set\r\n" +
                    "\t\tsbx[\"command\"] = self.element.xview\r\n"
                );
            }
        }

        private void mnPython_TKinterStringVariable_Click(object sender, RoutedEventArgs e) {
            insertText(
                            "\t\tself.var_inputfield1 = tkinter.StringVar()\r\n" +
                            "\t\tself.var_inputfield1.set(\"abc\")\r\n" +
                            "\t\tself.inputui1[\"textvariable\"] = self.var_inputfield1\r\n"
                        );
        }

        private void mnPython_TKinterIntVariable_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tself.var_inputfield1 = tkinter.IntVar()\r\n" +
                "\t\tself.var_inputfield1.set(12)\r\n" +
                "\t\tself.inputui1[\"textvariable\"] = self.var_inputfield1\r\n"
            );
        }

        private void mnPython_TKinterDoubleVariable_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tself.var_inputfield1 = tkinter.DoubleVar()\r\n" +
                "\t\tself.var_inputfield1.set(12.5)\r\n" +
                "\t\tself.inputui1[\"textvariable\"] = self.var_inputfield1\r\n"
            );
        }

        private void mnPython_TKinterCheckbuttonVariable_Click(object sender, RoutedEventArgs e) {
            if (ispack()) {

            }
            else {

            }
            insertText(
                "\t\tself.chkProperty1 = tkinter.BooleanVar()\r\n" +
                "\t\tself.chkProperty1.set(True)\t# self.chkProperty1.get()\r\n" +
                "\t\tself.inputui1[\"textvariable\"] = self.chkProperty1\r\n"
            );
        }

        private void mnPython_TKinterListboxInsert_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tself.listbox.insert(0,\"abc\")\r\n"
            );
        }

        private void mnPython_TKinterListboxAdd_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tself.listbox.insert(\"end\",\"abc\")\r\n"
            );
        }

        private void mnPython_TKinterListboxSelect_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tindizes = self.listbox.curselection()\t # tupel, selectmode=extended\r\n" +
                "\t\tindex = indizes[0]\r\n"
            );
        }

        private void mnPython_TKinterListboxGet_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\titem = self.listbox.get(index)\r\n"
            );
        }

        private void mnPython_TKinterListboxDelete_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tself.listbox.delete(0,\"end\")\r\n"
            );
        }

        private void mnPython_TKinterTextInsert_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tself.editor.insert(\"end\",\"abc\")\r\n"
            );
        }

        private void mnPython_TKinterTextDelete_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tself.editor.delete(1.0,\"end\")\r\n"
            );
        }

        private void mnPython_Foreground_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tuiElement.config(fg=\"red\")\r\n"
            );
        }

        private void mnPython_Background_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tuiElement.config(bg=\"yellow\")\r\n"
            );
        }

        private void mnPython_Anchor_Click(object sender, RoutedEventArgs e) {
            // N, NE, E, SE, S, SW, W, NW, or CENTER
            insertText(
                "\t\tuiElement.config(anchor=\"n\")\t# n, ne, e, se, s, sw, w, wn, center\r\n"
            );
        }

        private void mnPython_Justify_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tuiElement.config(justify=\"tkinter.LEFT\")\t# LEFT, RIGHT, or CENTER\r\n"
            );
        }

        private void mnPython_OkCancel_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tmessagebox.askokcancel( \"Meldung\", \"Ihre Festplatte wird formatiert\")\r\n" +
                "\t\t    # icon='question', error, warning, info, question\r\n"
            );
        }

        private void mnPython_YesNo_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tresult = messagebox.askyesno(\"Delete\", \"Are You Sure?\", \r\n" +
                "\t\t\ticon='question', default='no')\r\n" +
                "\t\tif result == True:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Deleted\",\"Deleted\")\r\n" +
                "\t\telse:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Not Deleted\",\"Not Deleted\")\r\n" +
                "\t\t    # icon='question', error, warning, info, question\r\n"
            );
        }

        private void mnPython_YesNoCancel_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tresult = messagebox.askyesnocancel( \"Beenden\", \"Änderungen speichern?\")\r\n" +
                "\t\tif result == True:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Beenden\",\"Save\")\r\n" +
                "\t\telif result == False:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Beenden\",\"No Save\")\r\n" +
                "\t\telif result == None:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Beenden\",\"No Close\")\r\n" +
                "\t\telse:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Beenden\",\"Fehlerhafte Abfrage\")\r\n" +
                "\t\t    # icon='question', error, warning, info, question\r\n\r\n"
            );
        }

        private void mnPython_RetryCancel_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tresult = messagebox.askretrycancel( \"Datei öffnen\", \"Fehler beim Öffnen, noch einmal versuchen?\")\r\n" +
                "\t\tif result == True:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Datei öffnen\",\"Noch einmal\")\r\n" +
                "\t\telse:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Datei öffnen\",\"Ende, kein weiterer Versuch\")\r\n" +
                "\t\t\t # messagebox.askokcancel( \"Note\", \"Sie erhalten eine 1,0\", default='yes')\r\n"
            );
        }

        private void mnPython_AskString_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tresult = simpledialog.askstring( \"Hello Python\", \"Hello World\")\r\n" +
                "\t\tif result == None:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Eingabe\",\"keine\")\r\n" +
                "\t\telse:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Eingabe\",result)\r\n"
            );
        }

        private void mnPython_AskInt_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tresult = simpledialog.askinteger( \"Hello Python\", \"Hello World\", initialvalue=42, minvalue=1, maxvalue=99)\r\n" +
                "\t\tif result == None:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Eingabe\",\"keine\")\r\n" +
                "\t\telse:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Eingabe\",result)\r\n"
            );
        }

        private void mnPython_AskFloat_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tresult = simpledialog.askfloat( \"Hello Python\", \"Hello World\", initialvalue=42.0, minvalue=1.0, maxvalue=99.9)\r\n" +
                "\t\tif result == None:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Eingabe\",\"keine\")\r\n" +
                "\t\telse:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Eingabe\",result)\r\n"
            );
        }

        private void mnPython_OpenDialog_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tfilename = filedialog.askopenfilename(title=\"Dateien laden\",\r\n" +
                "\t\t\t initialdir=\"D:/Daten\", multiple=False,\r\n" +
                "\t\t\t filetypes=( (\"Pythondateien\",\".py\" ),(\"Alle Dateien\",\"*.*\" ) ) )\r\n" +
                "\t\tif filename:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Eingabe\",filename)\r\n\r\n" +
                "\t\telse:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Auswahl\",\"Abbruch\")\r\n"
            );
        }

        private void mnPython_SaveDialog_Click(object sender, RoutedEventArgs e) {
            insertText(
                "\t\tfilename = filedialog.asksaveasfilename(initialfile=\"Beispiel.py\", \r\n" +
                "\t\t\t title=\"Dateien laden\", \r\n" +
                "\t\t\t initialdir=\"D:\\Python\\\",\r\n" +
                "\t\t\t filetypes=( (\"Pythondateien\",\".py\" ),(\"Alle Dateien\",\"*.*\" ) ) )\r\n" +
                "\t\tif filename:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Auswahl\",filename)   \r\n" +
                "\t\telse:\r\n" +
                "\t\t\tmessagebox.showinfo(\"Auswahl\",\"Abbruch\")\r\n"
            );
        }

        private void tabcontrol_SelectionChanged(object sender, SelectionChangedEventArgs e) {
            int index = tabcontrol.SelectedIndex;
            if (index >= 0) {
                MyTabItem tab = (MyTabItem)tabcontrol.Items[index];
                MyTextBox textbox = (MyTextBox)tab.Content;
                textbox.setFocus();
            }
        }

        private void Keydown_Click(Object sender, System.Windows.Input.KeyEventArgs e) {
            if (e.KeyboardDevice.IsKeyDown(Key.LeftCtrl) || e.KeyboardDevice.IsKeyDown(Key.RightCtrl)) {
                switch (e.Key) {
                    case Key.N:
                        NewFileExecuted(null, null);
                        break;
                    case Key.O:
                        OpenFileExecuted(null, null);
                        e.Handled = true;
                        break;
                    case Key.S:
                        // strg + shift s  => SaveAllExecuted
                        if (e.KeyboardDevice.IsKeyDown(Key.LeftShift) || e.KeyboardDevice.IsKeyDown(Key.RightShift))
                            SaveAllExecuted(null, null);
                        else
                            SaveExecuted(null, null);
                        e.Handled = true;
                        break;
                    case Key.F3:
                        FindAgainExecuted(null,null);
                        e.Handled = true;
                        break;

                    case Key.C:
                        CopyExecuted(null, null);
                        e.Handled = true;
                        break;
                    case Key.V:
                        PasteExecuted(null, null);
                        e.Handled = true;
                        break;
                    case Key.X:
                        CutExecuted(null, null);
                        e.Handled = true;
                        break;
                    case Key.Z:
                        UndoExecuted(null, null);
                        e.Handled = true;
                        break;
                    case Key.Y:
                        RedoExecuted(null, null);
                        e.Handled = true;
                        break;
                }
            }
            if (Keyboard.IsKeyDown(Key.Escape) && isFullscreen) {
                FullscreenTextExecuted(sender, null);
            }
        }



        private void mnClose_Click(object sender, RoutedEventArgs e) {
            Close();
        }


        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            MyTextBox edit;
            foreach (TabItem tabpage in tabcontrol.Items) {
                edit = (MyTextBox)tabpage.Content;
                if (edit.Modified) {
                    MessageBoxResult res = Basis.readYesNoCancel("Save the changes?", "Close the programm");
                    switch (res) {
                        case MessageBoxResult.Yes:
                            edit.saveFile();
                            break;
                        case MessageBoxResult.No:
                            break;
                        case MessageBoxResult.Cancel:
                            e.Cancel = true;
                            break;
                    }
                }
            }
            Basis.writeWindowPosition2Registry(this, SingVar.C_REG_ADR, windowname);

            if (!e.Cancel) {
                Basis.WriteRegInt(SingVar.C_REG_ADR, "files", tabcontrol.Items.Count);
                int i = 0;
                foreach (TabItem tabpage in tabcontrol.Items) {
                    edit = (MyTextBox)tabpage.Content;
                    Basis.WriteRegString(SingVar.C_REG_ADR, "file" + i, edit.Filename);
                    i++;
                }
            }
        }  // Window_Closing

        private void Window_PreviewMouseWheel(Object sender, MouseWheelEventArgs e) {
            if (Keyboard.Modifiers.HasFlag(ModifierKeys.Control)) {
                //Title = e.Delta.ToString();
                e.Handled = true;
                if (e.Delta > 0) {
                    editorfontsize += 2;
                    if (editorfontsize > 58) editorfontsize = 58;
                }
                else {
                    editorfontsize -= 2;
                    if (editorfontsize < 8) editorfontsize = 8;
                }
                setEditorFontsizeRegistry(editorfontsize);
            }

            if (Keyboard.Modifiers.HasFlag(ModifierKeys.Shift)) {
               // Title = e.Delta.ToString();
                e.Handled = true;
                if (e.Delta > 0) {
                    mainfontsize += 2;
                    if (mainfontsize > 58) mainfontsize = 58;
                }
                else {
                    mainfontsize -= 2;
                    if (mainfontsize < 8) mainfontsize = 8;
                }
                setFontsizeRegistry(mainfontsize);
            }



        }

    }
}
