import tkinter

class MyApp(tkinter.Frame):
	def __init__(self, master=None):
		tkinter.Frame.__init__(self, master)
		self.menuBar = tkinter.Menu(self)
		master.config(menu=self.menuBar)
		self.setGUI()
		self.pack()

	def setGUI(self):
		self.menuFile = tkinter.Menu(self.menuBar, tearoff=False)
		self.menuFile.add_command(label="Öffnen", command=self.openFile)
		self.menuFile.add_command(label="Speichern", command=self.saveFile)
		self.menuFile.add_command(label="Speichern unter", command=self.saveasFile)
		self.menuFile.add_separator() 

		self.menuSubFile = tkinter.Menu(self.menuBar, tearoff=False)
		self.menuSubFile.add_command(label="Sub1")
		self.menuSubFile.add_command(label="Sub2")
		self.menuSubFile.add_command(label="Sub3")
		self.menuFile.add_cascade(label="Sub1-3", menu=self.menuSubFile)

		self.menuFile.add_separator() 
		self.menuFile.add_command(label="Beenden", command=self.quit)
		self.menuBar.add_cascade(label="Datei", menu=self.menuFile)

		self.menuEdit = tkinter.Menu(self.menuBar, tearoff=False)
		self.menuEdit.add_command(label="Einfügen", command=self.insertClipboard)
		self.menuEdit.add_command(label="Kopieren", command=self.copyClipboard)
		self.menuBar.add_cascade(label="Edit", menu=self.menuEdit)

		self.editor = tkinter.Text(self)
		self.editor.pack(padx="5",pady="5")
        
	def openFile(self):
		self.editor.insert("end","openFile\r\n")

	def saveFile(self):
		self.editor.insert("end","saveFile\r\n")

	def saveasFile(self):
		self.editor.insert("end","saveasFile\r\n")

	def insertClipboard(self):
		self.editor.insert("end","insertClipboard\r\n")

	def copyClipboard(self):
		self.editor.insert("end","copyClipboard\r\n")

root = tkinter.Tk()
root.title("Mein Fenster")
root.geometry("250x300")
app = MyApp(root)
app.mainloop()